Bug 125326 - [Coordinated Graphics] '-webkit-mask-image: -webkit-gradient' doesn't work for AC layer.
Summary: [Coordinated Graphics] '-webkit-mask-image: -webkit-gradient' doesn't work fo...
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Layout and Rendering (show other bugs)
Version: 528+ (Nightly build)
Hardware: PC Linux
: P2 Normal
Assignee: Nobody
URL: http://black.company100.com/test/mask...
Keywords:
Depends on:
Blocks:
 
Reported: 2013-12-05 17:38 PST by Jeong Jin Gyeong
Modified: 2014-10-20 23:13 PDT (History)
9 users (show)

See Also:


Attachments
Patch (1.53 KB, patch)
2014-08-12 04:27 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.01 KB, patch)
2014-08-13 04:23 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.01 KB, application/octet-stream)
2014-08-13 04:24 PDT, Yonggeol Jung
no flags Details
Patch (2.01 KB, patch)
2014-08-13 04:25 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (1.63 KB, patch)
2014-08-13 04:54 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (1.68 KB, patch)
2014-08-13 06:29 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (1.68 KB, patch)
2014-08-13 06:53 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.42 KB, patch)
2014-08-13 07:43 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (1.68 KB, patch)
2014-08-13 07:48 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.04 KB, patch)
2014-10-20 05:18 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.03 KB, patch)
2014-10-20 19:01 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.03 KB, patch)
2014-10-20 19:37 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.03 KB, patch)
2014-10-20 21:13 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.16 KB, patch)
2014-10-20 21:31 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.16 KB, patch)
2014-10-20 21:37 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff
Patch (2.16 KB, patch)
2014-10-20 21:47 PDT, Yonggeol Jung
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Jeong Jin Gyeong 2013-12-05 17:38:38 PST
Test:
  http://black.company100.com/test/mask-image/


Google Chrome 27, GTK r160203 MiniBrowser display a green box correctly, but EFL r160203 MiniBrowser displays a red box.
Comment 1 Yonggeol Jung 2014-08-12 04:27:51 PDT
Created attachment 236439 [details]
Patch
Comment 2 Gyuyoung Kim 2014-08-13 02:56:57 PDT
Comment on attachment 236439 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=236439&action=review

> Source/WebCore/platform/graphics/texmap/coordinated/CoordinatedGraphicsLayer.cpp:810
> +        toCoordinatedGraphicsLayer(maskLayer())->syncPendingStateChangesIncludingSubLayers();

Please add test case for this fix.
Comment 3 Yonggeol Jung 2014-08-13 04:23:09 PDT
Created attachment 236513 [details]
Patch
Comment 4 Yonggeol Jung 2014-08-13 04:24:32 PDT
Created attachment 236514 [details]
Patch
Comment 5 Yonggeol Jung 2014-08-13 04:25:23 PDT
Created attachment 236515 [details]
Patch
Comment 6 Yonggeol Jung 2014-08-13 04:54:17 PDT
Created attachment 236516 [details]
Patch
Comment 7 Yonggeol Jung 2014-08-13 06:07:42 PDT
(In reply to comment #2)
> (From update of attachment 236439 [details])
> View in context: https://bugs.webkit.org/attachment.cgi?id=236439&action=review
> 
> > Source/WebCore/platform/graphics/texmap/coordinated/CoordinatedGraphicsLayer.cpp:810
> > +        toCoordinatedGraphicsLayer(maskLayer())->syncPendingStateChangesIncludingSubLayers();
> 
> Please add test case for this fix.

Related test case already exists.
(compositing/masks/mask-of-clipped-layer.html)
But, currently layout tests in compositing directory are marked as "skip" on EFL Port.
Comment 8 Yonggeol Jung 2014-08-13 06:11:12 PDT
(In reply to comment #7)
> (In reply to comment #2)
> > (From update of attachment 236439 [details] [details])
> > View in context: https://bugs.webkit.org/attachment.cgi?id=236439&action=review
> > 
> > > Source/WebCore/platform/graphics/texmap/coordinated/CoordinatedGraphicsLayer.cpp:810
> > > +        toCoordinatedGraphicsLayer(maskLayer())->syncPendingStateChangesIncludingSubLayers();
> > 
> > Please add test case for this fix.
> 
> Related test case already exists.
> (compositing/masks/mask-of-clipped-layer.html)
> But, currently layout tests in compositing directory are marked as "skip" on EFL Port.

I'll check more.
Comment 9 Yonggeol Jung 2014-08-13 06:29:27 PDT
Created attachment 236520 [details]
Patch
Comment 10 Yonggeol Jung 2014-08-13 06:53:41 PDT
Created attachment 236521 [details]
Patch
Comment 11 Yonggeol Jung 2014-08-13 07:43:58 PDT
Created attachment 236523 [details]
Patch
Comment 12 Yonggeol Jung 2014-08-13 07:48:39 PDT
Created attachment 236524 [details]
Patch
Comment 13 Yonggeol Jung 2014-10-20 05:18:05 PDT
Created attachment 240113 [details]
Patch
Comment 14 Gyuyoung Kim 2014-10-20 18:57:19 PDT
Comment on attachment 240113 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=240113&action=review

Currently EFL WebKitTestRunner doesn't enable AC as well as pixel test. So, I think this patch only can be verified locally.

> Source/WebCore/ChangeLog:15
> +

Could you add below line to here ?

Test : compositing/masks/mask-of-clipped-layer.html
Comment 15 Yonggeol Jung 2014-10-20 19:01:56 PDT
Created attachment 240174 [details]
Patch
Comment 16 Gyuyoung Kim 2014-10-20 19:33:36 PDT
Comment on attachment 240174 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=240174&action=review

> Source/WebCore/ChangeLog:13
> +        If layout test runs as AC mode, this test case will pass on EFL port.

Please add a new line here.

> Source/WebCore/ChangeLog:14
> +        Test : compositing/masks/mask-of-clipped-layer.html

Do not add a space in "Test :"

Just "Test:"
Comment 17 Yonggeol Jung 2014-10-20 19:37:48 PDT
Created attachment 240178 [details]
Patch
Comment 18 Yonggeol Jung 2014-10-20 21:13:33 PDT
Created attachment 240182 [details]
Patch
Comment 19 Gyuyoung Kim 2014-10-20 21:22:55 PDT
Comment on attachment 240182 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=240182&action=review

> Source/WebCore/ChangeLog:8
> +        Mask layer did not request to sync, so it wasn't shown.

YongGeol, I improve to clear this description a little.

"Mask layer hasn't requested to synchronize with AC layer in CoordinatedGraphics so far. That's why the mask layer isn't shown under CoordinatedGraphics.
Thus this patch lets the mask layer synchronize with the AC layer whenever AC layer is updated.

Below layout test case is related to this issue when --pixel test is enabled. Unfortunately EFL WebKitTestRunner doesn't support AC mode yet.
When EFL test framework supports AC mode, the test will be passed."
Comment 20 Yonggeol Jung 2014-10-20 21:31:12 PDT
Created attachment 240184 [details]
Patch
Comment 21 Yonggeol Jung 2014-10-20 21:34:24 PDT
Thanks for your detailed comments. :)
Comment 22 Yonggeol Jung 2014-10-20 21:37:07 PDT
Created attachment 240186 [details]
Patch
Comment 23 Yonggeol Jung 2014-10-20 21:47:01 PDT
Created attachment 240187 [details]
Patch
Comment 24 Gyuyoung Kim 2014-10-20 22:10:38 PDT
Comment on attachment 240187 [details]
Patch

As mentioned in ChangeLog, this fix can't be tested by EWebKit2 test framework yet. As talked with YongGeol locally, this fix was tested by Tizen product which enables AC mode. When AC will be supported by EWebKit trunk, this fix will be tested as well. rs=me.
Comment 25 WebKit Commit Bot 2014-10-20 23:12:54 PDT
Comment on attachment 240187 [details]
Patch

Clearing flags on attachment: 240187

Committed r174924: <http://trac.webkit.org/changeset/174924>
Comment 26 WebKit Commit Bot 2014-10-20 23:13:00 PDT
All reviewed patches have been landed.  Closing bug.